/* Alias.h
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr Aliase */

#include "Alias.h"
#include "ErrorLog.h"

extern int firstopenalias;

struct node *addalias(struct list *aliaslist,const char *title,const char *action)
{
  struct node *aliasnode;
  struct alias *alias;

  aliasnode=addnewnodetolist(aliaslist,sizeof(struct alias));

  if(aliasnode==0) logerror(errorlogwindow,"addalias(): aliasnode==0!");
  else
  {
    alias=aliasnode->data;
    if(alias==0) logerror(errorlogwindow,"addalias(): alias==0!");
    else
    {
      alias->title=malloc(strlen(title)+1);
      alias->action=malloc(strlen(action)+3);    /* +3: %n\0 am Ende */

      if(alias->title) strcpy(alias->title,title);
      if(alias->action)
      {
        strcpy(alias->action,action);
        if(strstr(action,"%n")==0) strcat(alias->action,"%n");
      }
    }
  }

  return aliasnode;
}

int checkalias(struct preferences *prefs,char *string)
{
  int number,len;
  char *command,*commandend;
  struct node *lookalias;

  number=-1;

  if(prefs->aliaslist)
  {
    commandend=strstr(string," ");

    if(commandend==0) len=strlen(string);
    else len=commandend-string;

    command=calloc(1,len+1);
    if(command==0) logerror(errorlogwindow,"checkalias(): command==0!");
    else
    {
      strncpy(command,string,len);
    }

    if(command)
    {
      int count=0;

      lookalias=prefs->aliaslist->head;

      while(lookalias)
      {
        struct alias *alias;

        alias=lookalias->data;

        if(strcasecmp(command,alias->title)==0) number=count;
        lookalias=lookalias->next;
        count++;
      } // endwhile
      free(command);
    }
  }

  return number;
}

void processalias(struct preferences *prefs,int number,char *string,struct server *server,struct channel *channel)
{
  struct node *aliasnode;

  aliasnode=getnodebynumber(prefs->aliaslist,number);
  if(aliasnode)
  {
    struct alias *alias;
    char *parameter;

    parameter=strstr(string," ");
    if(parameter) parameter++;

    alias=aliasnode->data;
    if(alias) parseaction(channel,alias->action,0,parameter);
  }
}

void selectalias(FD_AliasWindow *aliaswin,int numsel)
{
  if(numsel!=0)
  {
    fl_select_browser_line(aliaswin->AliasTitle,numsel);
    fl_select_browser_line(aliaswin->AliasList,numsel);
    fl_set_input(aliaswin->Label,fl_get_browser_line(aliaswin->AliasTitle,numsel));
    fl_set_input(aliaswin->Definition,fl_get_browser_line(aliaswin->AliasList,numsel));
  }
}

FD_AliasWindow *aliascontrol(FD_AliasWindow *aliaswin,FL_OBJECT *select)
{
  int quit,numsel;

  struct list *aliaslist;
  struct node *aliasnode;
  struct alias *alias;

  quit=0;
  aliaslist=prefs.aliaslist;

  if(firstopenalias==1 || select==aliaswin->Undo)
  {
    fl_set_input_return(aliaswin->Label,FL_RETURN_CHANGED);
    fl_set_input_return(aliaswin->Definition,FL_RETURN_CHANGED);

    fl_clear_browser(aliaswin->AliasTitle);
    fl_clear_browser(aliaswin->AliasList);

    fl_set_browser_vscrollbar(aliaswin->AliasTitle,0);  /* Nur eine Liste mit Scroller */
    fl_set_browser_hscrollbar(aliaswin->AliasTitle,0);  /* Keine Horizontalscroller */
    fl_set_browser_hscrollbar(aliaswin->AliasList,0);

    aliasnode=aliaslist->head;
    while(aliasnode)
    {
      alias=aliasnode->data;

      fl_add_browser_line(aliaswin->AliasTitle,alias->title);
      fl_add_browser_line(aliaswin->AliasList,alias->action);

      aliasnode=aliasnode->next;
    }

    firstopenalias=0;
    select=aliaswin->AliasTitle;
  }

  fl_set_browser_topline(aliaswin->AliasTitle,fl_get_browser_topline(aliaswin->AliasList));

  if(select==aliaswin->Delete)
  {
    numsel=fl_get_browser(aliaswin->AliasTitle);

    if(numsel!=0)
    {
      fl_delete_browser_line(aliaswin->AliasTitle,numsel);
      fl_delete_browser_line(aliaswin->AliasList,numsel);

      if(numsel>fl_get_browser_maxline(aliaswin->AliasTitle)) numsel--;
      selectalias(aliaswin,numsel);
    }
  }

  if(select==aliaswin->AliasTitle ||
     select==aliaswin->AliasList)
  {
    numsel=fl_get_browser(select);
    selectalias(aliaswin,numsel);   /* Eingabefelder werden hier auch aktualisiert */
  }

  if(select==aliaswin->Label ||
     select==aliaswin->Definition)
  {
    numsel=fl_get_browser(aliaswin->AliasTitle);

    if(numsel!=0)
    {
      fl_replace_browser_line(aliaswin->AliasTitle,numsel,fl_get_input(aliaswin->Label));
      fl_replace_browser_line(aliaswin->AliasList,numsel,fl_get_input(aliaswin->Definition));
    }
  }

  if(select==aliaswin->Add)
  {
    fl_addto_browser(aliaswin->AliasTitle,"");
    fl_addto_browser(aliaswin->AliasList,"");

    numsel=fl_get_browser_maxline(aliaswin->AliasTitle);
    selectalias(aliaswin,numsel);
  }

  if(select==aliaswin->Up)
  {
    numsel=fl_get_browser(aliaswin->AliasTitle);
    if(numsel>1)
    {
      swapbrowserline(aliaswin->AliasTitle,numsel,numsel-1);
      swapbrowserline(aliaswin->AliasList,numsel,numsel-1);

      selectalias(aliaswin,numsel-1);
    }
  }

  if(select==aliaswin->Down)
  {
    numsel=fl_get_browser(aliaswin->AliasTitle);
    if(numsel<fl_get_browser_maxline(aliaswin->AliasTitle))
    {
      swapbrowserline(aliaswin->AliasTitle,numsel,numsel+1);
      swapbrowserline(aliaswin->AliasList,numsel,numsel+1);

      selectalias(aliaswin,numsel+1);
    }
  }

  if(select==aliaswin->Save)
  {
    int count;

    freealiases(&prefs);

    numsel=fl_get_browser_maxline(aliaswin->AliasTitle);

    if(numsel!=0)
    {
      for(count=0;count<numsel;count++)
      {
        addalias(aliaslist,fl_get_browser_line(aliaswin->AliasTitle,count+1),fl_get_browser_line(aliaswin->AliasList,count+1));
      }
    }

    writeprefs(&prefs);

    quit=1;
  }

  if(select==aliaswin->Cancel) quit=1;

  if(quit==0) return aliaswin;
  else
  {
    fl_hide_form(aliaswin->AliasWindow);
    firstopenalias=1;
    readprefs(&prefs);
    return 0;
  }
}

void freealiases(struct preferences *prefs)
{
  struct node *lookalias,*nextalias;
  struct alias *alias;

  if(prefs->aliaslist)
  {
    lookalias=prefs->aliaslist->head;
    while(lookalias)
    {
      nextalias=lookalias->next;
      alias=lookalias->data;

      if(alias->title) free(alias->title);
      if(alias->action) free(alias->action);

      lookalias=freenode(lookalias);
    } // endwhile
  }
}
