/* Ban.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr die Bannliste */

#include "Ban.h"
#include "ErrorLog.h"
#include "Utils.h"

FD_BanWindow *openbanlist(struct channel *channel)
{
  char *command,*title;

  if(channel->banwin==0)
  {
    command=malloc(strlen(channel->name)+10); /* MODE <channel> +b\n\0 */
    if(command==0) logerror(errorlogwindow,"openbanlist(): command==0!");
    else
    {
      channel->banwin=create_form_BanWindow();
      fl_show_form(channel->banwin->BanWindow,FL_PLACE_MOUSE,FL_TRANSIENT,"Bannliste");

      sprintf(command,"MODE %s b",channel->name);
      transmitraw(channel->server->sock,command);

      sprintf(command,"MODE %s e",channel->name);
      transmitraw(channel->server->sock,command);

      free(command);

      title=malloc(strlen(channel->name)+15);   /* Bannliste fr <channel>\0 */
      if(title==0) logerror(errorlogwindow,"openbanlist(): title(ban)==0!");
      else
      {
        sprintf(title,"Bannliste fr %s",channel->name);
        fl_set_object_label(channel->banwin->BanListFrame,title);
        free(title);
      }

      title=malloc(strlen(channel->name)+19);   /* Ausnahmeliste fr <channel>\0 */
      if(title==0) logerror(errorlogwindow,"openbanlist(): title(except)==0!");
      else
      {
        sprintf(title,"Ausnahmeliste fr %s",channel->name);
        fl_set_object_label(channel->banwin->ExceptionListFrame,title);
        free(title);
      }

    }
  }
  return channel->banwin;
}

void closebanlist(struct channel *channel)
{
  if(channel->banwin==0) logerror(errorlogwindow,"closebanlist(): channel->banwin==0!");
  else fl_hide_form(channel->banwin->BanWindow);
}

FD_BanWindow *banlistcontrol(struct channel *channel,FL_OBJECT *select)
{
  FD_BanWindow *banwin;
  int quit,num,masklen;
  char *command,*mask;

  banwin=channel->banwin;

  quit=0;

  if(select==banwin->BanList)
  {
    num=fl_get_browser(banwin->BanList);
    if(num)
    {
      fl_set_input(banwin->BanMaskInput,fl_get_browser_line(banwin->BanList,num));
    }
  }

  if(select==banwin->ExceptionList)
  {
    num=fl_get_browser(banwin->ExceptionList);
    if(num)
    {
      fl_set_input(banwin->ExceptionMaskInput,fl_get_browser_line(banwin->ExceptionList,num));
    }
  }

  if(select==banwin->BanMaskInput)
  {
    if(lineexists(banwin->BanList,fl_get_input(banwin->BanMaskInput),CASE_IGNORE)) select=banwin->Unban;
    else select=banwin->Ban;
  }

  if(select==banwin->ExceptionMaskInput)
  {
    if(lineexists(banwin->ExceptionList,fl_get_input(banwin->ExceptionMaskInput),CASE_IGNORE)) select=banwin->UnExcept;
    else select=banwin->Except;
  }

  if(select==banwin->Ban)
  {
    ban(channel,fl_get_input(banwin->BanMaskInput));
  }

  if(select==banwin->Except)
  {
    except(channel,fl_get_input(banwin->ExceptionMaskInput));
  }

  if(select==banwin->Unban)
  {
    unban(channel,fl_get_input(banwin->BanMaskInput));
  }

  if(select==banwin->UnExcept)
  {
    unexcept(channel,fl_get_input(banwin->ExceptionMaskInput));
  }

  if(select==banwin->Close) quit=1;

  if(quit==0) return banwin;
  else
  {
    fl_hide_form(banwin->BanWindow);
    return 0;
  }
}

void addban(struct channel *channel,const char *banmask)
{
  FD_BanWindow *banwin;
  int found;

  banwin=channel->banwin;
  found=lineexists(banwin->BanList,banmask,CASE_IGNORE);

  if(!found) fl_add_browser_line(banwin->BanList,banmask);
}

void addexception(struct channel *channel,const char *exceptionmask)
{
  FD_BanWindow *banwin;
  int found;

  banwin=channel->banwin;
  found=lineexists(banwin->ExceptionList,exceptionmask,CASE_IGNORE);

  if(!found) fl_add_browser_line(banwin->ExceptionList,exceptionmask);
}

void removeban(struct channel *channel,const char *banmask)
{
  FD_BanWindow *banwin;
  int found;

  banwin=channel->banwin;

  found=lineexists(banwin->BanList,banmask,CASE_IGNORE);

  if(found) fl_delete_browser_line(banwin->BanList,found);
}

void removeexception(struct channel *channel,const char *exceptionmask)
{
  FD_BanWindow *banwin;
  int found;

  banwin=channel->banwin;

  found=lineexists(banwin->ExceptionList,exceptionmask,CASE_IGNORE);

  if(found) fl_delete_browser_line(banwin->ExceptionList,found);
}

void banunbanexcept(struct channel *channel,const char *mask,char *mode)
{
  int masklen;

// printf("DEBUG: banunban(channel,%s,%s)\n",mask,mode);

  masklen=strlen(mask);
  if(masklen)
  {
    char *command;

    command=malloc(strlen(channel->name)+masklen+11);    /* MODE <channel> [+/-][b/e] <hostmask>\n\0 */
    if(command==0) logerror(errorlogwindow,"banunban(): command==0!");
    else
    {
      sprintf(command,"MODE %s %s %s\n",channel->name,mode,mask);
      transmitraw(channel->server->sock,command);
      free(command);
    }
  }
}

/* Diese Funktkionen sind nach auen sichtbar */
void ban(struct channel *channel,const char *mask)
{
  banunbanexcept(channel,mask,"+b");
}

void unban(struct channel *channel,const char *mask)
{
  banunbanexcept(channel,mask,"-b");
}

void except(struct channel *channel,const char *mask)
{
  banunbanexcept(channel,mask,"+e");
}

void unexcept(struct channel *channel,const char *mask)
{
  banunbanexcept(channel,mask,"-e");
}
