/* Boom.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr das Crash-Fenster */

#include <signal.h>
#include <forms.h>

#include "Preferences.h"

#include "../Forms/SystemError.h"

void boom(int sig,void *data)
{
  FD_Boom *boomwindow;
  FL_OBJECT *selection;
  char errtxt[1024];
  struct preferences *prefs;

  prefs=data;

  if(sig!=SIGPIPE) closescriptport(prefs);

  if(sig==SIGINT)
  {
    printf("*** Unterbrechungssignal empfangen. FoxIRC wird beendet.\n");

    exit(0);
  }
  else
  {
    boomwindow=create_form_Boom();
    sprintf(errtxt,"Ein Systemfehler ist aufgetreten!\n"
                   "Der FoxIRC hat ein Fehlersignal empfangen:\n"
                   "Signalnummer: %d\n"
                   "Fehlerbeschreibung: %s\n%s",sig,strsignal(sig),(sig==SIGSEGV) ?
                   "Wenn dieser Fehler auftritt, kann der FoxIRC\n"
                   "nur noch beendet werden." :
                   "Mglicherweise kann der Programmablauf aber"
                   "trotzdem fortgesetzt werden.");

    fl_set_object_label(boomwindow->Textfield,errtxt);
    fl_show_form(boomwindow->Boom,FL_PLACE_MOUSE,FL_TRANSIENT,"FoxIRC Systemfehler");

    do
    {
      selection=fl_do_forms();
      if(selection==boomwindow->Quit) exit(1);
    } while(selection!=boomwindow->Continue);

    fl_hide_form(boomwindow->Boom);
    fl_signal_caught(sig);
  }
}
