/* DCC.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr die DCC-Funktionalitt */

#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <sys/shm.h>        /* shared memory */
#include <sys/stat.h>
#include <sys/types.h>
#include <netinet/in.h>

#ifndef SHUT_RDWR
#define SHUT_RDWR 2         /* Ist bei einem Tester nicht in den includes definiert gewesen */
#endif

#include "DCC.h"
#include "Nick.h"

extern char dccgetconn[];
extern int dccid;
extern FD_DCCGetStatus *dccgetwindow;
extern FD_DCCSend *dccsendwindow;
extern FD_RecipientWindow *recipientwindow;
extern struct dccdata *dcclist;
extern struct dccdisplay dccdisplay[MAXDCC];
extern struct server *server;
extern struct channel *activechannel;
extern struct preferences prefs;
extern struct filerequester dccrequester;

FD_DCCSend *opendccsend()
{
  if(dccsendwindow==0)
  {
    dccsendwindow=create_form_DCCSend();
    fl_show_form(dccsendwindow->DCCSend,FL_PLACE_FREE,FL_TRANSIENT,"DCC-Versand");
  }

  return dccsendwindow;
}

FD_RecipientWindow *openrecipient()
{
  struct channel *lookchannel;
  struct node *nicknode;
  struct nick *nick;

  if(recipientwindow==0)
  {
    recipientwindow=create_form_RecipientWindow();
    lookchannel=server->channel;

    while(lookchannel)
    {
      nicknode=lookchannel->nicknamelist->head;
      while(nicknode)
      {
        nick=nicknode->data;
        fl_add_browser_line(recipientwindow->NickList,nick->nick);
        nicknode=nicknode->next;
      }
      lookchannel=lookchannel->next;
    }

    sortbrowser(recipientwindow->NickList);
    fl_show_form(recipientwindow->RecipientWindow,FL_PLACE_FREE,FL_TRANSIENT,"Empfngerauswahl");
  }

  return recipientwindow;
}

FD_DCCGetStatus *opendccget()
{
  struct dccdata *dcc;
  int count;

  dcc=dcclist;

  if(dccgetwindow==0)
  {
    dccgetwindow=create_form_DCCGetStatus();

    fl_deactivate_object(dccgetwindow->ProcessBar1);        // Mu noch gendert werden.
    fl_deactivate_object(dccgetwindow->ProcessBar2);
    fl_deactivate_object(dccgetwindow->ProcessBar3);
    fl_deactivate_object(dccgetwindow->ProcessBar4);

    dccdisplay[0].control=dccgetwindow->DCC1Control;
    dccdisplay[1].control=dccgetwindow->DCC2Control;
    dccdisplay[2].control=dccgetwindow->DCC3Control;
    dccdisplay[3].control=dccgetwindow->DCC4Control;

    dccdisplay[0].sender=dccgetwindow->Sender1;
    dccdisplay[1].sender=dccgetwindow->Sender2;
    dccdisplay[2].sender=dccgetwindow->Sender3;
    dccdisplay[3].sender=dccgetwindow->Sender4;

    dccdisplay[0].name=dccgetwindow->DCC1NameInput;
    dccdisplay[1].name=dccgetwindow->DCC2NameInput;
    dccdisplay[2].name=dccgetwindow->DCC3NameInput;
    dccdisplay[3].name=dccgetwindow->DCC4NameInput;

    dccdisplay[0].bytecount=dccgetwindow->ByteCount1;
    dccdisplay[1].bytecount=dccgetwindow->ByteCount2;
    dccdisplay[2].bytecount=dccgetwindow->ByteCount3;
    dccdisplay[3].bytecount=dccgetwindow->ByteCount4;

    dccdisplay[0].cps=dccgetwindow->CPS1;
    dccdisplay[1].cps=dccgetwindow->CPS2;
    dccdisplay[2].cps=dccgetwindow->CPS3;
    dccdisplay[3].cps=dccgetwindow->CPS4;

    dccdisplay[0].processbar=dccgetwindow->ProcessBar1;
    dccdisplay[1].processbar=dccgetwindow->ProcessBar2;
    dccdisplay[2].processbar=dccgetwindow->ProcessBar3;
    dccdisplay[3].processbar=dccgetwindow->ProcessBar4;

    for(count=0;count<MAXDCC;count++) fl_set_object_color(dccdisplay[count].processbar,FL_MCOL,(dccgetconn[count]==2) ? COL_DCCSEND : COL_DCCGET);
    fl_show_form(dccgetwindow->DCCGetStatus,FL_PLACE_FREE,FL_TRANSIENT,"DCC-Status");
  }

  return dccgetwindow;
}

void dccgetadd(char *sendnick,char *dccname,char *dccsender,unsigned long dccip,long dccport,long dccsize)
{
  char dccserver[16],message[256];
  struct dccdata *newdcc, *search;
  int memid;

  sprintf(dccserver,"%d.%d.%d.%d",((unsigned char)(dccip/16777216) & 255),
                                  ((unsigned char)(dccip/65536) & 255),
                                  ((unsigned char)(dccip/256) & 255),
                                  ( unsigned char) dccip & 255);       // Unheimlich, nicht wahr?

  sprintf(message,"\\C%dDCC\t%s (%s) bietet die Datei '%s' (%lu Bytes) zum Download an.",COL_DCC,sendnick,dccserver,dccname,dccsize);
  displayirc(message,activechannel);

  memid=shmget(dccid++,sizeof(struct dccdata),0600 | IPC_CREAT);
  if(memid==-1) logerror(errorlogwindow,"dccgetadd(): shmget() failed!");
  else
  {
    newdcc=shmat(memid,NULL,0);     // NULL = Adresse kommt vom System
    if(newdcc==(void *)-1) logerror(errorlogwindow,"dccgetadd(): shmat() failed!");
    else
    {
      newdcc->memid=memid;

      search=dcclist;
      if(search==0) dcclist=newdcc;
      else
      {
        while(search->next!=0) search=search->next;
        search->next=newdcc;
      }

      newdcc->prev=search;
      newdcc->next=0;

      strcpy(newdcc->server,dccserver);

      newdcc->type=DCC_GET;
      newdcc->status=STATUS_PENDING;
      newdcc->ip=dccip;
      newdcc->port=dccport;
      newdcc->filesize=dccsize;
      newdcc->actualsize=0;
      newdcc->oldsize=0;
      newdcc->stallcount=0;
      newdcc->socket2=-1;
      newdcc->connection=-1;                       // Noch keine Nummer zugewiesen

      sprintf(newdcc->name,"%s%s",prefs.dccpath,dccname);
      strcpy(newdcc->sender,dccsender);

      dccgetwindow=opendccget();
    }
  }
}

void dccsendadd(char *destnick,char *dccfind,char *dccname)
{
  char dccserver[16],message[256];
  struct dccdata *newdcc, *search;
  unsigned long dccsize;
  int memid;
  struct stat fileinfo;

  if(stat(dccfind,&fileinfo)==-1) printf("dccsendadd(): stat() for '%s' failed. %d %s\n",dccfind,errno,strerror(errno));
  else
  {
    dccsize=fileinfo.st_size;

    sprintf(message,"\\C%dDCC\tBiete %s die Datei '%s' (%lu Bytes) zum Download an.",COL_DCC,destnick,dccname,dccsize);
    displayirc(message,activechannel);
//    printf("shared mem needed: %d\n",sizeof(struct dccdata));

    memid=shmget(dccid++,sizeof(struct dccdata),0600 | IPC_CREAT);
    if(memid==-1) printf("dccsendadd(): shmget() failed! %d %s\n",errno,strerror(errno));
    else
    {
      newdcc=shmat(memid,NULL,0);     // NULL = Adresse kommt vom System
      if(newdcc==(void *)-1) logerror(errorlogwindow,"dccsendadd(): shmat() failed!");
      else
      {
        newdcc->memid=memid;

        search=dcclist;
        if(search==0) dcclist=newdcc;
        else
        {
          while(search->next!=0) search=search->next;
          search->next=newdcc;
        }
 
        newdcc->prev=search;
        newdcc->next=0;

        strcpy(newdcc->server,dccserver);

        newdcc->type=DCC_SEND;
        newdcc->status=STATUS_PENDING;
        newdcc->filesize=dccsize;
        newdcc->actualsize=0;
	newdcc->acked=0;
        newdcc->oldsize=0;
        newdcc->stallcount=0;
        newdcc->socket2=-1;
        newdcc->connection=-1;                       // Noch keine Nummer zugewiesen

        strcpy(newdcc->find,dccfind);
        strcpy(newdcc->name,dccname);

        strcpy(newdcc->recipient,destnick);
        dccgetwindow=opendccget();
      }
    }
  }
}

FD_DCCSend *dccsendcontrol(FD_DCCSend *dccsend,FL_OBJECT *select)
{
  int quit;

  quit=0;

  if(select==dccsend->Cancel && dccrequester.active==0) quit=1;

  if(select==dccsend->ChooseFile && dccrequester.active==0)
  {
    deactivate(dccsend->Cancel);
    deactivate(dccsend->Send);
    deactivate(dccsend->ChooseFile);
    openfilerequester(&dccrequester,"Datei auswhlen",prefs.dccpath);
  }

  if(select==dccsend->ChooseRecipient && recipientwindow==0)
  {
    deactivate(dccsend->Cancel);
    deactivate(dccsend->Send);
    deactivate(dccsend->ChooseRecipient);
    recipientwindow=openrecipient();
  }

  if(recipientwindow)
  {
    if(select==recipientwindow->Choose)
    {
      int numsel;

      numsel=fl_get_browser(recipientwindow->NickList);
      if(numsel)
      {
        fl_set_input(dccsend->Recipient,fl_get_browser_line(recipientwindow->NickList,numsel));
      }
    }

    if(select==recipientwindow->Cancel || select==recipientwindow->Choose)
    {
      fl_hide_form(recipientwindow->RecipientWindow);
      recipientwindow=0;

      activate(dccsend->ChooseRecipient);

      if(dccrequester.active==0)
      {
        activate(dccsend->Send);
        activate(dccsend->Cancel);
      }
    }
  }

  if(dccrequester.active!=0)
  {
    dccrequester.active=requestercontrol(&dccrequester,select);
    if(dccrequester.active==0)
    {
      activate(dccsend->ChooseFile);

      if(recipientwindow==0)
      {
        activate(dccsend->Send);
        activate(dccsend->Cancel);
      }
    }
  }

  if(dccrequester.okay==1)
  {
    dccrequester.okay=0;
    fl_set_input(dccsend->Filename,dccrequester.find);
  }

  if(select==dccsend->Send && dccrequester.active==0)
  {
    char *recipient,*name,*find;
    int len,findlen;

    len=strlen(fl_get_input(dccsend->Recipient));
    findlen=strlen(fl_get_input(dccsend->Filename));

    if(len && findlen)
    {
      recipient=calloc(1,len+1);
      if(recipient)
      {
        strcpy(recipient,fl_get_input(dccsend->Recipient));
        find=calloc(1,findlen+1);
        if(find)
        {
          strcpy(find,fl_get_input(dccsend->Filename));
          name=rindex(find,'/');
          if(name) name++;
          dccsendadd(recipient,find,name);
          free(find);
        }
        free(recipient);
      }
    }
    quit=1;
  }

  if(quit==0) return dccsend;
  else
  {
    fl_hide_form(dccsend->DCCSend);
    return 0;
  }
}

FD_DCCGetStatus *dccgetcontrol(FD_DCCGetStatus *dccget,FL_OBJECT *select)
{
  int quit;

  quit=0;

  if(select==dccget->Close) quit=1;

  if(quit==0) return dccget;
  else
  {
    fl_hide_form(dccget->DCCGetStatus);
    return 0;
  }
}

int connectdcc(struct dccdata *dcc)
{
  int returndccsock,result,len;
  struct sockaddr_in dccsockaddr;
  struct hostent *dcchost;

//  printf("Connecting DCC to IP %s Port %d\n",dcc->server,dcc->port);

  returndccsock=0;

  bzero((caddr_t)&dccsockaddr,sizeof(dccsockaddr));

  dcchost=gethostbyname(dcc->server);
  dcc->socket=socket(dcchost->h_addrtype,SOCK_STREAM,0);  // sys/socket.h
// FIXME: Bei O_NONBLOCK, bricht die Verbindung sofort wieder ab

  if(dcc->socket!=-1)
  {
    result=bind(dcc->socket,(struct sockaddr *)&dccsockaddr,sizeof(dccsockaddr));
    if(result>=0)
    {
      dccsockaddr.sin_family=dcchost->h_addrtype;
      dccsockaddr.sin_port=htons(dcc->port);
      bcopy(dcchost->h_addr,(char *)&dccsockaddr.sin_addr,dcchost->h_length);
      len=sizeof(dccsockaddr);

      result=connect(dcc->socket,(struct sockaddr *)&dccsockaddr,len);
      if(result!=-1) returndccsock=dcc->socket;
    }
  }
  return returndccsock;
}

void handledcc(FL_OBJECT *selection)
{
  FILE *out;
  long received,delta,dummy,ack[1];
  unsigned char transstr[LINELEN],message[256],response[DCCGETBUF],transfer[DCCSENDBUF];
  struct dccdata *dcc,*dccnext;
  struct sockaddr_in dccsockaddr,remotesockaddr;
  struct in_addr ip;
  socklen_t remotelen;
  int cps,count,closedcc,child,memid,result;

  dcc=dcclist;

  while(dcc!=0)
  {
    closedcc=0;

    if(dcc->type==DCC_SEND)
    {
      if(dcc->status==STATUS_PENDING)
      {
        if(dcc->connection==-1)
        {
          count=0;
          while(count!=MAXDCC && dccgetconn[count]!=0) count++;
          if(count!=MAXDCC)
          {
            dccgetconn[count]=2;                   /* 2 fr Send, 1 fr Get */
            dcc->connection=count;
            if(dccgetwindow!=0)
            {
              fl_set_slider_value(dccdisplay[dcc->connection].processbar,0);                     /* Prozentbalken auf 0 */
              fl_set_object_color(dccdisplay[dcc->connection].processbar,FL_MCOL,COL_DCCSEND);   /* Farbe setzen */
            }
          }
        }
        else
        {
          closedcc=1;          /* falls open(), socket() oder listen() fehlschlagen. */

          dcc->handle=open(dcc->find,O_RDONLY);
          if(dcc->handle==-1) printf("handledcc(): Open source file '%s' failed. %d %s\n",dcc->find,errno,strerror(errno));
          else
          {
            bzero((caddr_t) &dccsockaddr,sizeof(dccsockaddr));
 
            dcc->socket=socket(PF_INET,SOCK_STREAM,0);
            if(dcc->socket!=-1)
            {
              fcntl(dcc->socket,F_SETFL,O_NONBLOCK);
 
              dcc->port=1024;                             /* <1024 nur fr root */
              dccsockaddr.sin_port=htons(dcc->port);
 
              while(bind(dcc->socket,(struct sockaddr *) &dccsockaddr,sizeof(dccsockaddr))<0) dccsockaddr.sin_port=htons(++dcc->port); // Suche nach freiem Port

              result=listen(dcc->socket,10);
              if(result==0)
              {
                ip.s_addr=server->myip.s_addr;

                sprintf(transstr,"PRIVMSG %s :%cDCC SEND %s %u %lu %lu%c",dcc->recipient,1,dcc->name,ntohl(ip.s_addr),dcc->port,dcc->filesize,1);
                transmitraw(server->sock,transstr);
 
                dcc->status=STATUS_CONNECTING;
                closedcc=0;
              }
              else logerror(errorlogwindow,"makedccsendsocket(): listen() failed.");
            }
            else logerror(errorlogwindow,"makedccsendsocket(): socket() failed.");
          }
        }
      }

      if(dcc->status==STATUS_CONNECTING)
      {
        if(dccgetwindow!=0) fl_set_object_label(dccdisplay[dcc->connection].bytecount,"biete an");

        remotelen=sizeof(dccsockaddr);
        result=accept(dcc->socket,&remotesockaddr,&remotelen);

        if(result>0)
        {
          dcc->status=STATUS_RUNNING;               // socket2 kann wohl bald raus
          dcc->socket2=result;
          fcntl(dcc->socket2,F_SETFL,O_NONBLOCK);

  	  shutdown(dcc->socket,SHUT_RDWR);
  	  close(dcc->socket);
  	  dcc->socket=-1;

          fl_gettime(&dcc->starttime,&dummy);

          child=fork();
          if(child==0)
          {
            while(dcc->status==STATUS_RUNNING)
            {
              result=read(dcc->handle,transfer,DCCSENDBUF);
              if(result==-1)
              {
                printf("handledcc(): read() failed. Code %d (%s)\n",result,strerror(errno));
                dcc->status=STATUS_FAILED;
              }
              else
              {
                if(write(dcc->socket2,transfer,result)==-1)
                {
                  dcc->status=STATUS_FAILED;
                }
                else
                {
                  dcc->actualsize+=result;

                  while(read(dcc->socket2,&ack,4)!=4);    // ==4)

                  dcc->acked=ntohl(ack[0]);

                  if(dcc->actualsize==dcc->filesize)
                  {
                    if(dcc->acked==dcc->filesize) dcc->status=STATUS_COMPLETE;
                  }
                }          // Ich hasse Treppensteigen
              }
            }  // endwhile
            exit(0);
          }
        }
      }

      if(dccgetwindow!=0)
      {
        if(selection==dccdisplay[dcc->connection].control) dcc->status=STATUS_FAILED;
      }

      if(dcc->status==STATUS_COMPLETE)
      {
	sprintf(message,"\\C%dDCC\tDCC Versand der Datei '%s' abgeschlossen.",COL_DCC,dcc->name);
        displayirc(message,activechannel);

        closedcc=1;
      }

      if(dcc->status==STATUS_FAILED)
      {
        sprintf(message,"\\C%dDCC\tDCC Versand der Datei '%s' fehlgeschlagen (%s).",COL_DCC,dcc->name,strerror(errno));
        displayirc(message,activechannel);
        if(dccgetwindow!=0) fl_set_object_label(dccdisplay[dcc->connection].bytecount,"fehlgeschlagen");

        closedcc=1;
      }
    }

    else if(dcc->type==DCC_GET)
    {
      if(dcc->status==STATUS_PENDING)
      {
        if(dcc->connection==-1)
        {
          count=0;
          while(count!=MAXDCC && dccgetconn[count]!=0) count++;
          if(count!=MAXDCC)
          {
            dccgetconn[count]=1;                   // 2 fr Send, 1 fr Get
            dcc->connection=count;
            if(dccgetwindow!=0)
            {
              fl_set_slider_value(dccdisplay[dcc->connection].processbar,0);                    // Prozentbalken auf 0
              fl_set_object_color(dccdisplay[dcc->connection].processbar,FL_MCOL,COL_DCCGET);   // Farbe setzen
            }
          }
        }
        else
        {
          if(dccgetwindow!=0)
          {
            fl_set_object_label(dccdisplay[dcc->connection].bytecount,"wartet");
            if(selection==dccdisplay[dcc->connection].control) dcc->status=STATUS_CONNECTING;
          }
        }
      }                                  // Ich erfe, also bin ich furry

      if(dcc->status==STATUS_FAILED)
      {
        sprintf(message,"\\C%dDCC\tDCC Empfang der Datei '%s' fehlgeschlagen (%s).",COL_DCC,dcc->name,strerror(errno));
        displayirc(message,activechannel);
        if(dccgetwindow!=0) fl_set_object_label(dccdisplay[dcc->connection].bytecount,"fehlgeschlagen");

        closedcc=1;
      }

      if(dcc->status==STATUS_CONNECTING)
      {
        dcc->status=STATUS_FORKING;        // Damit nicht nochmal geforkt wird, wenn der connect() lnger dauert

        if(dccgetwindow!=0) fl_set_object_label(dccdisplay[dcc->connection].cps,"verbinde ...");

        child=fork();
        if(child==0)
        {
          if(connectdcc(dcc)==0)
          {
            dcc->status=STATUS_FAILED;

            closedcc=1;
          }
          else
          {
            dcc->status=STATUS_RUNNING;

        // printf("DCC-Child established.\n");
            while((dcc->actualsize!=dcc->filesize) && !closedcc)
            {
              received=read(dcc->socket,response,sizeof(response));
              if(received!=-1)
              {
                if(dcc->actualsize==0) fl_gettime(&dcc->starttime,&dummy);

                out=fopen(dcc->name,(dcc->actualsize==0) ? "w" : "a");
                if(out==0)
                {
                  printf("handledcc(): fopen('%s') failed.\n",dcc->name);
                  dcc->status=STATUS_FAILED;
                  closedcc=1;
                }
                else
                {
                  fwrite(response,sizeof(char),received,out);
                  fclose(out);
                }

                dcc->actualsize+=received;
//              if(received!=sizeof(response))
//              {
                ack[0]=htonl(dcc->actualsize);
                if(write(dcc->socket,ack,4)==-1) logerror(errorlogwindow,"handledcc(): write(ack) failed!");
//              }
              }
              else
              {
                if(errno!=EAGAIN)
                {
                  dcc->status=STATUS_FAILED;
                  closedcc=1;
                }
              }
            } // endwhile
          }
       // printf("DCC-Child exiting.\n");
          exit(0);
        }
      }

      if(dcc->actualsize==dcc->filesize)
      {
        dcc->status=STATUS_COMPLETE;

        sprintf(message,"\\C%dDCC\tDCC Empfang der Datei '%s' abgeschlossen.",COL_DCC,dcc->name);
        displayirc(message,activechannel);

        closedcc=1;
      }
    }    // ende DCC_GET

    if(dccgetwindow!=0)
    {
      if(dcc->connection!=-1)
      {
        fl_set_object_label(dccdisplay[dcc->connection].sender,(dcc->type==DCC_GET) ? dcc->sender : dcc->recipient);
        fl_set_object_label(dccdisplay[dcc->connection].name,dcc->name);
      }

      if(dcc->status==STATUS_RUNNING)
      {
        fl_gettime(&delta,&dummy);
        cps=dcc->actualsize/(delta-dcc->starttime+.01);

        sprintf(message,"%ld / %ld",dcc->actualsize,dcc->filesize);
        fl_set_object_label(dccdisplay[dcc->connection].bytecount,message);

        sprintf(message,"%d",cps);
        fl_set_object_label(dccdisplay[dcc->connection].cps,message);
        fl_set_slider_value(dccdisplay[dcc->connection].processbar,(double)(100*dcc->actualsize/dcc->filesize));
      }

      if(dcc->status==STATUS_COMPLETE)
      {
        sprintf(message,"komplett (%ld)",dcc->actualsize);
        fl_set_object_label(dccdisplay[dcc->connection].bytecount,message);
        fl_set_slider_value(dccdisplay[dcc->connection].processbar,100);
      }
    }

    if(closedcc==1)
    {
/*      printf("Closing DCC-%s request %s %s with name %s\n",(dcc->type==DCC_GET) ? "GET" : "SEND",
                                                           (dcc->type==DCC_GET) ? "from" : "to",
                                                           (dcc->type==DCC_GET) ? dcc->sender : dcc->recipient,
                                                            dcc->name); */
      if (dcc->socket!=-1)
      {
        shutdown(dcc->socket,SHUT_RDWR);
	close(dcc->socket);
      }
      if (dcc->socket2!=-1)
      {
        shutdown(dcc->socket2,SHUT_RDWR);
	close(dcc->socket2);
      }

      if(dcc->handle) close(dcc->handle);

      dccgetconn[dcc->connection]=0;
      dcc->status=STATUS_REMOVE;
    }

    dcc=dcc->next;
  } // endwhile

  dcc=dcclist;

  while(dcc!=0)
  {
    dccnext=dcc->next;

    if(dcc->status==STATUS_REMOVE)
    {
/*      printf("Removing DCC-%s request %s %s with name %s\n",(dcc->type==DCC_GET) ? "GET" : "SEND",
                                                            (dcc->type==DCC_GET) ? "from" : "to",
                                                            (dcc->type==DCC_GET) ? dcc->sender : dcc->recipient,
                                                             dcc->name); */
      if(dcc->prev==0)
      {
        dcclist=dcc->next;
        if(dcclist!=0) dcclist->prev=0;             // Mann, hast DU eine Ausdauer :))
      }
      else
      {
        dcc->prev->next=dcc->next;
        if(dcc->next!=0) dcc->next->prev=dcc->prev;
      }

      memid=dcc->memid;
      shmdt(dcc);
      shmctl(memid,IPC_RMID,NULL);
    }

    dcc=dccnext;
//    printf("dcclist: %d\n",dcclist);
  } // endwhile
}

