/* Events.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr die Ereignis-Funktionen */

#include "Events.h"

extern int eventwasopen;
extern struct preferences prefs;
extern struct list *eventlist;

FD_EventPrefsWindow *openeventprefs()
{
  FD_EventPrefsWindow *event;

  event=create_form_EventPrefsWindow();

  eventwasopen=0;

  setformgeo(event->EventPrefsWindow,&prefs.geoevent);

  fl_set_input_return(event->NameInput,FL_RETURN_CHANGED);
  fl_set_input_return(event->ParameterInput,FL_RETURN_CHANGED);
  fl_set_input_return(event->TextInput,FL_RETURN_CHANGED);
  fl_set_input_return(event->ScriptInput,FL_RETURN_CHANGED);
  fl_set_input_return(event->SoundInput,FL_RETURN_CHANGED);

  fl_show_form(event->EventPrefsWindow,FL_PLACE_POSITION,FL_TRANSIENT,"Ereignisse");

  return event;
}

void selectevent(FD_EventPrefsWindow *event,int num)
{
  struct node *lookeventnode;
  struct event *lookevent;

  if(eventlist)
  {
    fl_select_browser_line(event->EventList,num+1);

    lookeventnode=getnodebynumber(eventlist,num);
    if(lookeventnode)
    {
      lookevent=lookeventnode->data;

      fl_set_input(event->NameInput,lookevent->name);
      fl_set_input(event->ParameterInput,lookevent->parameter);
      fl_set_input(event->TextInput,lookevent->text);
      fl_set_input(event->ScriptInput,lookevent->script);
      fl_set_input(event->SoundInput,lookevent->sound);

      fl_set_choice(event->EventChoice,lookevent->type+1);
    }
    else
    {
      fl_set_input(event->NameInput,"");
      fl_set_input(event->ParameterInput,"");
      fl_set_input(event->TextInput,"");
      fl_set_input(event->ScriptInput,"");
      fl_set_input(event->SoundInput,"");

      fl_set_choice(event->EventChoice,1);
    }
  }
}

void updateevent(FD_EventPrefsWindow *event,int num)
{
  struct node *lookeventnode;
  struct event *lookevent;

  lookeventnode=getnodebynumber(eventlist,num);
  lookevent=lookeventnode->data;

  free(lookevent->name);
  lookevent->name=malloc(strlen(fl_get_input(event->NameInput))+1);
  strcpy(lookevent->name,fl_get_input(event->NameInput));

  free(lookevent->parameter);
  lookevent->parameter=malloc(strlen(fl_get_input(event->ParameterInput))+1);
  strcpy(lookevent->parameter,fl_get_input(event->ParameterInput));

  free(lookevent->text);
  lookevent->text=malloc(strlen(fl_get_input(event->TextInput))+1);
  strcpy(lookevent->text,fl_get_input(event->TextInput));

  free(lookevent->script);
  lookevent->script=malloc(strlen(fl_get_input(event->ScriptInput))+1);
  strcpy(lookevent->script,fl_get_input(event->ScriptInput));

  free(lookevent->sound);
  lookevent->sound=malloc(strlen(fl_get_input(event->SoundInput))+1);
  strcpy(lookevent->sound,fl_get_input(event->SoundInput));

  lookevent->type=fl_get_choice(event->EventChoice)-1;
}

FD_EventPrefsWindow *eventprefscontrol(FD_EventPrefsWindow *event,FL_OBJECT *select)
{
  int quit,numsel;
  struct node *lookeventnode;
  struct event *lookevent;
  char soundname[512];

  quit=0;

  if(eventwasopen==0)
  {
    eventwasopen=1;
    if(eventlist)
    {
      lookeventnode=eventlist->head;
      while(lookeventnode)
      {
        lookevent=lookeventnode->data;
        fl_add_browser_line(event->EventList,lookevent->name);
        lookeventnode=lookeventnode->next;
      }

      selectevent(event,0);
    }
  }

  if(select==event->Add)
  {
    fl_addto_browser(event->EventList,"Neues Ereignis");
    addevent(0,"Neues Ereignis","","","","");
    selectevent(event,fl_get_browser_maxline(event->EventList)-1);
  }

  if(select==event->Delete)
  {
    numsel=fl_get_browser(event->EventList);

    if(eventlist && eventlist->head)
    {
      lookeventnode=eventlist->head;
      remevent(getnodebynumber(eventlist,numsel-1));

      fl_delete_browser_line(event->EventList,numsel);

      if(numsel>fl_get_browser_maxline(event->EventList)) numsel--;
      selectevent(event,numsel-1);
    }
  }

  if(eventlist && eventlist->head)
  {
    if(select==event->NameInput ||
       select==event->ParameterInput ||
       select==event->TextInput ||
       select==event->ScriptInput ||
       select==event->SoundInput ||
       select==event->EventChoice)
    {
      fl_replace_browser_line(event->EventList,fl_get_browser(event->EventList),fl_get_input(event->NameInput));
      updateevent(event,fl_get_browser(event->EventList)-1);
    }
  }

  if(select==event->EventList)
  {
    selectevent(event,fl_get_browser(event->EventList)-1);
  }

  if(select==event->Play)
  {
    strcpy(soundname,fl_get_input(event->SoundInput));
    if(strlen(soundname)!=0)
    {
      queuesound(soundname);
    }
  }

  if(select==event->Save)
  {
    writeprefs(&prefs);
    quit=1;
  }

  if(select==event->Cancel) quit=1;

  if(quit==0) return event;
  else
  {
    saveformgeo(event->EventPrefsWindow,&prefs.geoevent);
    fl_hide_form(event->EventPrefsWindow);
    readprefs(&prefs);
    return 0;
  }
}
