/* Nick.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Hilfsfunktionen fr Nicknames */

#include <stdlib.h>

#include "Nick.h"
#include "ErrorLog.h"

struct node *getnicknode(struct list *list,char *nick)
{
  struct node *returnnode;
  unsigned char found;
  struct nick *looknick;
  char *needle;

  returnnode=0;

  needle=malloc(strlen(nick)+1);
  if(needle==0) logerror(errorlogwindow,"getnicknode(): needle==0!");
  else
  {
    int count;

    strcpy(needle,nick);

    count=strlen(needle);
    while(--count) if(needle[count]==' ') needle[count]=0; /* trim */

    if(list==0) logerror(errorlogwindow,"getnicknode(): list==0!");
    else
    {
      if(nick==0) logerror(errorlogwindow,"getnicknode(): nick==0!");
      else
      {
        found=0;
        returnnode=list->head;

        while(!found && returnnode)
        {
          looknick=returnnode->data;
          if(strcasecmp(looknick->nick,needle)==0) found=1;
          else
          {
            returnnode=returnnode->next;
          }
        } // endwhile
      }
    }
    free(needle);
  }
  return returnnode;
}

void addhostmasktonick(struct channel *channel,char *sendnick,char *mask)
{
  if(channel)
  {
    struct node *node;

    if(node=getnicknode(channel->nicknamelist,sendnick))
    {
      struct nick *nick;

      nick=node->data;
      if(nick->hostmask==0)
      {
//        printf("New Hostmask:%s\n",mask);
        nick->hostmask=malloc(strlen(mask)+1);  /* +1 fr \0 */
        if(nick->hostmask) strcpy(nick->hostmask,mask);
      }
//      else printf("Old Hostmask:%s\n",nick->hostmask);
    }
  }
}

void getnickhostmask(struct channel *channel,char *mask)
{
  if(channel)
  {
    char sendnick[LINELEN+1];
    int count;

    count=0;
    while(mask[count]!='!' && mask[count]!=0) sendnick[count]=mask[count++];
    sendnick[count]=0;
    addhostmasktonick(channel,sendnick,mask+strlen(sendnick)+1);  /* +1 berspringt das "!" in der Mitte */
  }
}
