/* Topic.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr die Topic-Liste */

#include "Constants.h"
#include "ErrorLog.h"
#include "Topic.h"
#include "Preferences.h"

extern struct preferences prefs;
extern struct server *server;

void displaytopic(FD_MainWindow *window,char *string)
{
  fl_set_input(window->TopicLine,string);
}

void addtopictolist(struct topic *topic,FD_TopicListWindow *topiclistwindow)
{
  char topicline[LINELEN];
  sprintf(topicline,"%s\t%s",topic->nick,topic->topic);

  fl_addto_browser(topiclistwindow->TopicList,topicline);
}

void addtopic(char *topic,char *nick,struct channel *channel)
{
  struct node *newtopicnode;
  struct topic *newtopic;

  if(channel->topiclist==0) channel->topiclist=newlist();

  if(channel->topiclist==0) logerror(errorlogwindow,"addtopic(): channel->topiclist==0!");
  else
  {
    newtopicnode=addnewnodetolist(channel->topiclist,sizeof(struct topic));
    if(newtopicnode==0) logerror(errorlogwindow,"addtopic(): newtopicnode==0!");
    else
    {
      newtopic=newtopicnode->data;

      newtopic->topic=malloc(strlen(topic)+1);   // Ende mit \0 mitberechnen
      if(newtopic->topic==0) logerror(errorlogwindow,"addtopic(): newtopic->topic==0!");
      else strcpy(newtopic->topic,topic);

      newtopic->nick=malloc(strlen(nick)+1);   // Ende mit \0 mitberechnen
      if(newtopic->nick==0) logerror(errorlogwindow,"addtopic(): newtopic->nick==0!");
      else strcpy(newtopic->nick,nick);

      if(channel->topiclistwin!=0) addtopictolist(newtopic,channel->topiclistwin);
    }
  }
}

struct node *remtopic(struct node *topicnode)
{
  struct topic *topic;
  struct node *returnnode;

  returnnode=0;

  if(topicnode==0) logerror(errorlogwindow,"remtopic(): topicnode==0!");
  else
  {
    returnnode=unlinknode(topicnode);

    topic=topicnode->data;
    if(topic==0) logerror(errorlogwindow,"remtopic(): topic==0!");
    else
    {
      free(topic->topic);
      free(topic->nick);
    }

    freenode(topicnode);
  }
  return returnnode;
}

void freetopics(struct channel *channel)
{
  if(channel->topiclist) while(remtopic(channel->topiclist->head)!=0);
}

void closetopiclist(struct channel *channel)
{
  saveformgeo(channel->topiclistwin->TopicListWindow,&prefs.geotopiclist);
  fl_hide_form(channel->topiclistwin->TopicListWindow);
}

FD_TopicListWindow *opentopiclist(struct channel *channel)
{
  struct node *node;
  struct topic *looktopic;
  char title[256];

  sprintf(title,"Themenliste fr Kanal %s",channel->name);

  channel->topiclistwin=create_form_TopicListWindow();

  if(channel->topiclist)   // Ein Kanal ohne Topic erzeugt noch keine Liste!
  {
    node=channel->topiclist->head;
    while(node)
    {
      looktopic=node->data;
      addtopictolist(looktopic,channel->topiclistwin);
      node=node->next;
    }
  }
  setformgeo(channel->topiclistwin->TopicListWindow,&prefs.geotopiclist);
  fl_show_form(channel->topiclistwin->TopicListWindow,FL_PLACE_POSITION,FL_TRANSIENT,title);

  return channel->topiclistwin;
}

FD_TopicListWindow *topiclistcontrol(struct channel *channel,FL_OBJECT *select)
{
  char *command,*rawtopic;
  int quit,num,len;
  FD_TopicListWindow *topiclist;

  topiclist=channel->topiclistwin;

  quit=0;
  if(select==topiclist->ToTopic)
  {
    num=fl_get_browser(topiclist->TopicList);
    if(num)
    {
      len=strlen(fl_get_browser_line(topiclist->TopicList,num));
      rawtopic=calloc(1,len+1);

      if(rawtopic==0) logerror(errorlogwindow,"topiclistcontrol(): rawtopic==0!");
      else
      {
        strcpy(rawtopic,fl_get_browser_line(topiclist->TopicList,num));

        // Berechne bentigten Speicherplatz fr Topic-Kommando: "TOPIC #channel :topic"

        len=strlen(strstr(rawtopic,"\t")+1);
        len+=strlen(channel->name);

        len+=9;       // TOPIC + 2 Leer + 1 ":" + 1 \0

        command=calloc(1,len+1);
        if(command==0) logerror(errorlogwindow,"topiclistcontrol(): command==0!");
        else
        {
          sprintf(command,"TOPIC %s :%s",channel->name,strstr(rawtopic,"\t")+1);

          transmitraw(server->sock,command);
          free(command);
        }

        free(rawtopic);
      }
    }
  }

  if(select==topiclist->Close) quit=1;

  if(quit==0) return topiclist;
  else
  {
    closetopiclist(channel);
    return 0;
  }
}
